package net.sf.jftp.net;

import net.sf.jftp.util.*;
import net.sf.jftp.*;

import com.sshtools.j2ssh.transport.*;


public class SftpVerification extends AbstractHostKeyVerification
{

    public SftpVerification() throws InvalidHostFileException
    {
    }

    public void onDeniedHost(final String host)
                                            throws TransportProtocolException
    {
             Log.debug( "Access to '" + host + "' is denied.\nVerify the access granted/denied in the allowed hosts file.");
    }

    public void onHostKeyMismatch(final String host, final String recordedFingerprint,
                                  final String actualFingerprint)
                                            throws TransportProtocolException
    {
	try
	{
                        allowHost(host, actualFingerprint, false);
        }
        catch(Exception ex)
	{
	 	Log.debug("Error: " + ex);
	}
    }

    public void onUnknownHost(final String host, final String fingerprint)  throws TransportProtocolException
     {
	 try
	 {
                     allowHost(host, fingerprint, false);
         }
        catch(Exception ex)
	{
	 	Log.debug("Error: " + ex);
	}
    }


    private void showExceptionMessage(Exception ex)
    {
    	Log.debug("Error: " + ex);
    }

}
